#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 4 "yacc.y"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
  
  struct Desc{
    char *wholetag;             /* whole tag;*/
    char *tag;                  /* tag of transition (first part);*/
    char **labels;              /* labels of transition;*/
    int nl;                     /* number of labels;*/
    char *end;                  /* string to distinguish;*/
    struct Desc *next;
  };

  struct RestSet{
    char **labels;     /* Labels that are synchronized*/
    int nl;            /* number of labels*/
  };

  int istrrest;

  extern int Tr_or_Pl;                    /* Tr. or Pl under parsing*/
  extern int Tr_Rest;                     /* is there restriction on labels of tr-s*/
  extern int Pl_Rest;                     /* is there restriction on labels of pl-s*/
  extern struct RestSet PlaceRest;        /* Labels of places to be sybchronised*/
  extern struct RestSet TransRest;        /* Labels of transitions to be sybchronised*/
  extern struct Desc *PDesc;
  extern int Restriction;
  extern char *rlabels[20];

  void Copy_Name(char *str)
    {
      PDesc->tag=(char *)malloc(sizeof(char)*(strlen(str)+1));
      strcpy(PDesc->tag,str);
    }
  
  void Copy_End(char *str)
    {
      PDesc->end=(char *)malloc(sizeof(char)*(strlen(str)+1));
      strcpy(PDesc->end,str);
    }

  void Copy_Label(char *str)
    {
      int rest,ii;
      int isrest;
      struct RestSet *R;

      isrest=Tr_Rest;
      R=&TransRest;
      if(Tr_or_Pl==0)
	{
	  isrest=Pl_Rest;
	  R=&PlaceRest;
	}

      if(!isrest) { rest=0;}
      else
	{
	  rest=1;
	  for(ii=0;ii<R->nl;ii++)
	    if(strcmp(R->labels[ii],str)==0) rest=0;
	}
      if(!rest)
	{
	  if(PDesc->nl==0)
	    {PDesc->labels=(char **)malloc(sizeof(char *)*10);}
	  PDesc->labels[PDesc->nl]=(char*)malloc(sizeof(char)*(strlen(str)+1)); 	 
          strcpy(PDesc->labels[PDesc->nl],str);
 	  PDesc->nl++;
	}
    }

  void Fill_Rest(char *str)
    {
      struct RestSet *R;

      if(istrrest) { R=&TransRest; }
      else { R=&PlaceRest; }
      if(R->nl==0)
	{R->labels=(char **)malloc(sizeof(char *)*100);}
      R->labels[R->nl]=(char *)malloc(sizeof(char)*(strlen(str)+1));
      strcpy(R->labels[R->nl],str);
      R->nl++; 
    }
#line 90 "yacc.y"
typedef union {
  char *SVal; } YYSTYPE;
#line 105 "y.tab.c"
#define YYERRCODE 256
#define ID 257
#define BAR 258
#define NEWLINE 259
#define B_WAVE 260
#define E_WAVE 261
#define EQUAL 262
#define PL 263
#define TR 264
const short yylhs[] = {                                        -1,
    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    3,    3,    4,    5,    2,    7,    2,    6,    6,    6,
    8,
};
const short yylen[] = {                                         2,
    1,    1,    6,    5,    2,    4,    1,    2,    3,    4,
    1,    3,    1,    0,    6,    0,    6,    0,    1,    3,
    1,
};
const short yydefred[] = {                                      0,
    0,    0,   16,   14,    0,    1,    2,    0,   13,    0,
   11,    0,    0,    0,    0,    0,    0,    0,   10,    0,
    0,   12,    0,    0,    0,    4,   21,    0,   19,    0,
    3,    0,   17,   15,   20,
};
const short yydgoto[] = {                                       5,
    6,    7,   10,   11,   13,   28,   12,   29,
};
const short yysindex[] = {                                   -257,
 -255, -246,    0,    0,    0,    0,    0, -243,    0, -238,
    0, -240, -237, -236, -235, -241, -234, -233,    0, -239,
 -229,    0, -228, -228, -227,    0,    0, -256,    0, -249,
    0, -228,    0,    0,    0,
};
const short yyrindex[] = {                                      0,
   24,    0,    0,    0,    0,    0,    0,   31,    0,   32,
    0,    0,    0,    0,   33,    0,    0,    0,    0,    0,
   34,    0, -248, -248,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
    0,    0,   27,  -12,    0,   12,    0,    5,
};
#define YYTABLESIZE 37
const short yytable[] = {                                       1,
    2,   32,    8,   22,   33,    3,    4,   22,   32,   18,
    9,   34,   18,    9,   14,    9,   21,    9,   25,   16,
   19,   17,   20,    7,   18,   23,   24,   26,   27,   31,
    8,    5,    9,    6,   15,   30,   35,
};
const short yycheck[] = {                                     257,
  258,  258,  258,   16,  261,  263,  264,   20,  258,  258,
  257,  261,  261,  257,  258,  257,  258,  257,  258,  258,
  257,  262,  258,    0,  262,  260,  260,  257,  257,  257,
    0,    0,    0,    0,    8,   24,   32,
};
#define YYFINAL 5
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 264
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ID","BAR","NEWLINE","B_WAVE",
"E_WAVE","EQUAL","PL","TR",
};
const char * const yyrule[] = {
"$accept : string",
"string : fulltag",
"string : set_of_labels",
"fulltag : ID BAR labels BAR BAR ID",
"fulltag : BAR labels BAR BAR ID",
"fulltag : BAR labels",
"fulltag : BAR labels BAR BAR",
"fulltag : ID",
"fulltag : ID BAR",
"fulltag : ID BAR labels",
"fulltag : ID BAR BAR ID",
"labels : label",
"labels : labels BAR label",
"label : ID",
"$$1 :",
"set_of_labels : TR $$1 EQUAL B_WAVE rlabels E_WAVE",
"$$2 :",
"set_of_labels : PL $$2 EQUAL B_WAVE rlabels E_WAVE",
"rlabels :",
"rlabels : rlabel",
"rlabels : rlabels BAR rlabel",
"rlabel : ID",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 132 "yacc.y"










































#line 273 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 3:
#line 108 "yacc.y"
{Copy_Name(yyvsp[-5].SVal); Copy_End(yyvsp[0].SVal);}
break;
case 4:
#line 109 "yacc.y"
{Copy_End(yyvsp[0].SVal);}
break;
case 7:
#line 112 "yacc.y"
{Copy_Name(yyvsp[0].SVal);}
break;
case 8:
#line 113 "yacc.y"
{Copy_Name(yyvsp[-1].SVal);}
break;
case 9:
#line 114 "yacc.y"
{Copy_Name(yyvsp[-2].SVal);}
break;
case 10:
#line 115 "yacc.y"
{Copy_Name(yyvsp[-3].SVal);Copy_End(yyvsp[0].SVal);}
break;
case 13:
#line 120 "yacc.y"
{Copy_Label(yyvsp[0].SVal);}
break;
case 14:
#line 122 "yacc.y"
{istrrest=1; Tr_Rest=1;}
break;
case 16:
#line 123 "yacc.y"
{istrrest=0; Pl_Rest=1;}
break;
case 21:
#line 129 "yacc.y"
{Fill_Rest(yyvsp[0].SVal);}
break;
#line 508 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
